package ink.wgink.module.file.media.service.rtmp;

import ink.wgink.pojo.ListPage;
import ink.wgink.pojo.result.SuccessResultList;
import ink.wgink.module.file.media.pojo.dtos.rtmp.RtmpClientDTO;
import ink.wgink.module.file.media.pojo.vos.rtmp.RtmpClientVO;
import ink.wgink.module.file.media.pojo.bos.rtmp.RtmpClientBO;
import ink.wgink.module.file.media.pojo.pos.rtmp.RtmpClientPO;

import java.util.List;
import java.util.Map;

/**
 * @ClassName: IClientService
 * @Description: rtmp客户端
 * @Author: CodeFactory
 * @Date: 2022-04-26 22:03:44
 * @Version: 3.0
 **/
public interface IRtmpClientService {

    /**
     * 新增rtmp客户端
     *
     * @param rtmpClientVO
     * @return
     */
    void save(RtmpClientVO rtmpClientVO);

    /**
     * 新增rtmp客户端
     *
     * @param token
     * @param rtmpClientVO
     * @return
     */
    void save(String token, RtmpClientVO rtmpClientVO);

    /**
     * 新增rtmp客户端
     *
     * @param rtmpClientVO
     * @return clientId
     */
    String saveReturnId(RtmpClientVO rtmpClientVO);

    /**
     * 新增rtmp客户端
     *
     * @param token
     * @param rtmpClientVO
     * @return clientId
     */
    String saveReturnId(String token, RtmpClientVO rtmpClientVO);

    /**
     * 删除rtmp客户端
     *
     * @param ids id列表
     * @return
     */
    void remove(List<String> ids);


    /**
     * 删除rtmp客户端
     *
     * @param token
     * @param ids id列表
     * @return
     */
    void remove(String token, List<String> ids);

    /**
     * 删除rtmp客户端（物理删除）
     *
     * @param ids id列表
     */
    void delete(List<String> ids);

    /**
     * 修改rtmp客户端
     *
     * @param clientId
     * @param rtmpClientVO
     * @return
     */
    void update(String clientId, RtmpClientVO rtmpClientVO);

    /**
     * 修改rtmp客户端
     *
     * @param token
     * @param clientId
     * @param rtmpClientVO
     * @return
     */
    void update(String token, String clientId, RtmpClientVO rtmpClientVO);

    /**
     * rtmp客户端详情
     *
     * @param params 参数Map
     * @return
     */
    RtmpClientDTO get(Map<String, Object> params);

    /**
     * rtmp客户端详情
     *
     * @param clientId
     * @return
     */
    RtmpClientDTO get(String clientId);

    /**
     * rtmp客户端详情
     *
     * @param params 参数Map
     * @return
     */
    RtmpClientBO getBO(Map<String, Object> params);

    /**
     * rtmp客户端详情
     *
     * @param clientId
     * @return
     */
    RtmpClientBO getBO(String clientId);

    /**
     * rtmp客户端详情
     *
     * @param params 参数Map
     * @return
     */
    RtmpClientPO getPO(Map<String, Object> params);

    /**
     * rtmp客户端详情
     *
     * @param clientId
     * @return
     */
    RtmpClientPO getPO(String clientId);

    /**
     * rtmp客户端列表
     *
     * @param params
     * @return
     */
    List<RtmpClientDTO> list(Map<String, Object> params);

    /**
     * rtmp客户端列表
     *
     * @param params
     * @return
     */
    List<RtmpClientBO> listBO(Map<String, Object> params);

    /**
     * rtmp客户端列表
     *
     * @param params
     * @return
     */
    List<RtmpClientPO> listPO(Map<String, Object> params);

    /**
     * rtmp客户端分页列表
     *
     * @param page
     * @return
     */
    SuccessResultList<List<RtmpClientDTO>> listPage(ListPage page);

    /**
     * rtmp客户端统计
     *
     * @param params
     * @return
     */
    Integer count(Map<String, Object> params);

}